diff --git a/tests/amdgpu/amdgpu_test.c b/tests/amdgpu/amdgpu_test.c
index 8fa3399a4101ccac3e2c..f28e7c6636e4b644bfd2 100644
--- a/tests/amdgpu/amdgpu_test.c
+++ b/tests/amdgpu/amdgpu_test.c
@@ -243,7 +243,6 @@ static const char options[]   = "hlrps:t:b:d:f";
 static int amdgpu_open_devices(int open_render_node)
 {
 	drmDevicePtr devices[MAX_CARDS_SUPPORTED];
-	int ret;
 	int i;
 	int drm_node;
 	int amd_index = 0;
diff --git a/tests/amdgpu/basic_tests.c b/tests/amdgpu/basic_tests.c
index 6ee0aa3b044aeffc6adf..354b015758559c164415 100644
--- a/tests/amdgpu/basic_tests.c
+++ b/tests/amdgpu/basic_tests.c
@@ -681,7 +681,7 @@ static void amdgpu_command_submission_compute_nop(void)
 	struct amdgpu_cs_fence fence_status;
 	uint32_t *ptr;
 	uint32_t expired;
-	int i, r, instance;
+	int r, instance;
 	amdgpu_bo_list_handle bo_list;
 	amdgpu_va_handle va_handle;
 	struct drm_amdgpu_info_hw_ip info;
@@ -1473,7 +1473,7 @@ static void amdgpu_sync_dependency_test(void)
 	struct amdgpu_cs_ib_info ib_info;
 	struct amdgpu_cs_fence fence_status;
 	uint32_t expired;
-	int i, j, r, instance;
+	int i, j, r;
 	amdgpu_bo_list_handle bo_list;
 	amdgpu_va_handle va_handle;
 	static uint32_t *ptr;
diff --git a/tests/amdgpu/cs_tests.c b/tests/amdgpu/cs_tests.c
index 4880b74f8114d02ec1df..a5361cd59457d039dea9 100644
--- a/tests/amdgpu/cs_tests.c
+++ b/tests/amdgpu/cs_tests.c
@@ -273,7 +273,7 @@ static void amdgpu_cs_uvd_create(void)
 
 static void amdgpu_cs_uvd_decode(void)
 {
-	const unsigned dpb_size = 15923584, ctx_size = 5287680, dt_size = 737280;
+	const unsigned dpb_size = 15923584, dt_size = 737280;
 	uint64_t msg_addr, fb_addr, bs_addr, dpb_addr, ctx_addr, dt_addr, it_addr;
 	struct amdgpu_bo_alloc_request req = {0};
 	amdgpu_bo_handle buf_handle;
diff --git a/tests/amdgpu/deadlock_tests.c b/tests/amdgpu/deadlock_tests.c
index cd34cdf673a645dbdac0..b38a260fe83d33894003 100644
--- a/tests/amdgpu/deadlock_tests.c
+++ b/tests/amdgpu/deadlock_tests.c
@@ -109,7 +109,6 @@ CU_BOOL suite_deadlock_tests_enable(void)
 
 int suite_deadlock_tests_init(void)
 {
-	struct amdgpu_gpu_info gpu_info = {0};
 	int r;
 
 	r = amdgpu_device_initialize(drm_amdgpu[0], &major_version,
@@ -176,7 +175,7 @@ static void amdgpu_deadlock_helper(unsigned ip_type)
 	struct amdgpu_cs_ib_info ib_info;
 	struct amdgpu_cs_fence fence_status;
 	uint32_t expired;
-	int i, r, instance;
+	int i, r;
 	amdgpu_bo_list_handle bo_list;
 	amdgpu_va_handle va_handle;
 
diff --git a/tests/amdgpu/uvd_enc_tests.c b/tests/amdgpu/uvd_enc_tests.c
index bed8494a8b666fbda58e..0377c1a5d7e1b789d782 100644
--- a/tests/amdgpu/uvd_enc_tests.c
+++ b/tests/amdgpu/uvd_enc_tests.c
@@ -247,8 +247,6 @@ static void free_resource(struct amdgpu_uvd_enc_bo *uvd_enc_bo)
 
 static void amdgpu_cs_uvd_enc_create(void)
 {
-	int len, r;
-
 	enc.width = 160;
 	enc.height = 128;
 
@@ -263,7 +261,7 @@ static void check_result(struct amdgpu_uvd_enc *enc)
 	uint64_t sum;
 	uint32_t s = 175602;
 	uint32_t *ptr, size;
-	int i, j, r;
+	int j, r;
 
 	r = amdgpu_bo_cpu_map(enc->fb.handle, (void **)&enc->fb.ptr);
 	CU_ASSERT_EQUAL(r, 0);
@@ -470,7 +468,6 @@ static void amdgpu_cs_uvd_enc_encode(void)
 
 static void amdgpu_cs_uvd_enc_destroy(void)
 {
-	struct amdgpu_uvd_enc_bo sw_ctx;
 	int len, r;
 
 	num_resources  = 0;
diff --git a/tests/amdgpu/vcn_tests.c b/tests/amdgpu/vcn_tests.c
index 9224bc371a462bea140a..2eb8c4347be094a70958 100644
--- a/tests/amdgpu/vcn_tests.c
+++ b/tests/amdgpu/vcn_tests.c
@@ -283,7 +283,7 @@ static void amdgpu_cs_vcn_dec_create(void)
 
 static void amdgpu_cs_vcn_dec_decode(void)
 {
-	const unsigned dpb_size = 15923584, ctx_size = 5287680, dt_size = 737280;
+	const unsigned dpb_size = 15923584, dt_size = 737280;
 	uint64_t msg_addr, fb_addr, bs_addr, dpb_addr, ctx_addr, dt_addr, it_addr, sum;
 	struct amdgpu_vcn_bo dec_buf;
 	int size, len, i, r;
diff --git a/tests/amdgpu/vm_tests.c b/tests/amdgpu/vm_tests.c
index 5f1831076ef9c517197f..75fcb2dbb5bc1de0204b 100644
--- a/tests/amdgpu/vm_tests.c
+++ b/tests/amdgpu/vm_tests.c
@@ -35,7 +35,6 @@ static void amdgpu_vmid_reserve_test(void);
 
 int suite_vm_tests_init(void)
 {
-	struct amdgpu_gpu_info gpu_info = {0};
 	int r;
 
 	r = amdgpu_device_initialize(drm_amdgpu[0], &major_version,
@@ -78,10 +77,9 @@ static void amdgpu_vmid_reserve_test(void)
 	struct amdgpu_cs_ib_info ib_info;
 	struct amdgpu_cs_fence fence_status;
 	uint32_t expired, flags;
-	int i, r, instance;
+	int i, r;
 	amdgpu_bo_list_handle bo_list;
 	amdgpu_va_handle va_handle;
-	union drm_amdgpu_vm vm;
 	static uint32_t *ptr;
 
 	r = amdgpu_cs_ctx_create(device_handle, &context_handle);